/*==============================================================================
	CArrange.hpp
==============================================================================*/

#ifndef __CARRANGE__HPP__
#define __CARRANGE__HPP__

#include "CGadget.hpp"
#include "CMainDialog.hpp"
#include "CSample.hpp"
#include "CSampleList.hpp"
#include "CWaveOutBuffer.hpp"
#include "..\resources\resource.h"

/*==============================================================================
	Constantes
==============================================================================*/

#define TIMERID_MOVE				1
#define TIMERDELAY_MOVE				150
#define MOVE_RECT_SIZE				40
#define SAMPLE_STATE_MOVING			1
#define TIME_PRECISION				1000 // millisecondes

/*==============================================================================
	Classe
==============================================================================*/

class CMainDialog;
class CSample;
class CSampleList;
class CWaveOutBuffer;
class CArrange : public CGadget
{

	public:

		CSampleList				*gSampleMap;
		CMainDialog				*gParent;

		CArrange(CMainDialog *);

		// Mix
		void			playMix(void);
		void			stopMix(void);
		int				writeProc(char*);
		static int		stWriteProc(LPVOID, char*);

	protected:

		CSample			*_gPreview;
		WAVEFORMATEX	_wFormatPreview;
		int				_iPreviewBufferSize;
		int				_iPreviewBufferPosition;
		int				_timeBarHeight;
		int				_trackBarWidth;
		int				_timeScale;
		int				_trackScale;
		BOOL			_isScrollingHorz;
		BOOL			_isScrollingVert;
		unsigned long	_playPos;
		int				_bSampleState;

		// WndProc
		void			onCreate(LPARAM);
		void			onScroll(UINT, WPARAM, LPARAM);
		void			onPaint(void);
		void			onLeftButtonDown(WPARAM, LPARAM);
		void			onRightButtonDown(WPARAM, LPARAM);
		void			onMouseMove(WPARAM, LPARAM);
		void			onLeftButtonUp(WPARAM, LPARAM);
		void			onLeftButtonDoubleClick(WPARAM, LPARAM);
		void			onDragDrop(WPARAM, LPARAM);
		void			onTimer(WPARAM, LPARAM);
		void			onCommand(WPARAM, LPARAM);
		int				gadgetProc(UINT, WPARAM, LPARAM);

		// Paint
		void			paintSampleMap(HDC, int, int, int, int);
		void			paintTimeBar(HDC, int, int);
		void 			paintTrackBar(HDC, int, int);
		void			rePaint(void);
		BOOL			isSampleVisible(CSample*);

		// Rect
		BOOL			isPointInRect(RECT, long, long);
		BOOL			isRectVisibleInRect(RECT, RECT);
		RECT			getTimeBarRect(void);
		RECT			getTrackBarRect(void);
		RECT			getSampleMapRect(void);
		RECT			getSampleRect(CSample*);
		LONG			getScrollPos(int);
		void			moveScrollPos(int, int);
		BOOL			isInLeftMoveRect(int, int);
		BOOL			isInRightMoveRect(int, int);
		BOOL			isInUpMoveRect(int, int);
		BOOL			isInDownMoveRect(int, int);
		unsigned long	getOffsetTime(void);
		int				getOffsetTrack(void);
		int				getVisibleTime(void);
		int				getVisibleTrack(void);

		// Sample
		CSample			*addSample(CSample*);
		CSample 		*selectSample(int, int);
		void			moveSample(CSample*, int, int);
		void			unselectAllSamples(void);
		CSample			*getSelectedSample(void);
		void			setSelectedSample(CSample*);
		void			deleteSelectedSamples(void);
		void			deleteAllSamples(void);

		// Mix
		CWaveOutBuffer	*_gWaveOutBuffer;

};

#endif

/* Fin de CArrange.hpp */
