/*==============================================================================
	CArrange.cpp
==============================================================================*/

#include "CArrangeTimeBar.hpp"

/*==============================================================================
	Constructeur
==============================================================================*/

CArrangeTimeBar::CArrangeTimeBar(CArrange *parent) : gParent(parent)
{

	WNDCLASSEX wc;

	// Rcupre le parent
	// = parent;

	// Proprits
	strcpy(className, ARRANGEMENT_TIMEBAR_CLASSNAME);
	dwStyle 	= WS_HSCROLL|WS_VSCROLL|WS_VISIBLE|WS_CHILD|WS_BORDER;
	dwStyleEx 	= 0;
	wId			= IDC_ARRANGE_TIMEBAR;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(wc);
	wc.style			= CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC)stGadgetProc;
	wc.hInstance		= gParent->hInstance;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.lpszClassName	= className;
	RegisterClassEx(&wc);

	open(gParent->hInstance, gParent->hWnd);

}

/*==============================================================================
	onCreate
==============================================================================*/

void CArrangeTimeBar::onCreate(LPARAM lParam)
{

	MessageBox(0, 0, 0, 0);

}

/*==============================================================================
	onPaint
==============================================================================*/

void CArrangeTimeBar::onPaint(void)
{

	PAINTSTRUCT ps;
	HDC hdc;
	HBRUSH hBrush;
	RECT controlRect, rc;
	char lpzBuf[12];
	int offsetTime, offsetTrack, visibleTime;
	int i;

	//std::list<CSample>::iterator iter;

	// Rcupre les coordonnes du gadget
	GetClientRect(hWnd, &controlRect);

	// Rcupre la partie visible de la table
	offsetTime = 0;//getHScroll(hWnd);
	offsetTrack = 0;//CArrange_GetVScroll(hWnd);
	visibleTime = ( controlRect.right - controlRect.left );

	// Couleur du fond
	hBrush	= CreateSolidBrush(RGB(255, 0, 0));

	// Commence le dessin
	hdc = BeginPaint(hWnd, &ps);

	// Couleur du texte
	SetTextColor(hdc, RGB(0, 0, 0));

	// Dessine le fond
	FillRect(hdc, &controlRect, hBrush);

	// Libre la mmoire
	EndPaint(hWnd, &ps);

	// Libre les pinceaux
	DeleteObject(hBrush);

}

/*==============================================================================
	gadgetProc
==============================================================================*/

int CArrangeTimeBar::gadgetProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch ( uMsg ) {

		case WM_CREATE:
			onCreate(lParam);
			break;

		case WM_LBUTTONDOWN:
			//MessageBox(0, 0, 0, 0);
			break;

		case WM_PAINT:
			onPaint();
			break;

		default:
			return 0;

	}
	return 1;

}

/* Fin de CArrange.cpp */
