/*==============================================================================
	CGadget.cpp
==============================================================================*/

#include "CGadget.hpp"

/*==============================================================================
	Destructeur
==============================================================================*/

CGadget::~CGadget()
{

	close();

}

/*==============================================================================
	registerClass
==============================================================================*/

BOOL CGadget::registerClass(WNDCLASSEX *wc)
{

	wc->lpfnWndProc		= (WNDPROC)stGadgetProc;
	strcpy(_className, wc->lpszClassName);
	RegisterClassEx(wc);

}

/*==============================================================================
	unregisterClass
==============================================================================*/

void CGadget::unregisterClass(void)
{

	UnregisterClass(_className, getInstance());

}

/*==============================================================================
	open
==============================================================================*/

HWND CGadget::open(HINSTANCE hInstance, HWND hWndParent, char *lpStr)
{

	return CreateWindowEx(dwStyleEx, _className, lpStr, dwStyle, 0, 0, 0, 0,
				hWndParent, (HMENU)wId, hInstance, this);

}

/*==============================================================================
	close
==============================================================================*/

BOOL CGadget::close(void)
{

	DestroyWindow(hWnd);
	hWnd = NULL;

}

/*==============================================================================
	getInstance
==============================================================================*/

HINSTANCE CGadget::getInstance(void)
{

	HINSTANCE	hInstance;
	hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	return hInstance;

}

/*==============================================================================
	getUserData
==============================================================================*/

LONG CGadget::getUserData(void)
{

	LONG		lData;
	lData = GetWindowLong(hWnd, GWL_USERDATA);
	return lData;

}

/*==============================================================================
	setUserData
==============================================================================*/

void CGadget::setUserData(LONG lData)
{

	SetWindowLong(hWnd, GWL_USERDATA, lData);

}

/*==============================================================================
	getClientRect
==============================================================================*/

RECT CGadget::getClientRect(void)
{

	RECT		lpRect;
	GetClientRect(hWnd, &lpRect);
	return lpRect;

}

/*==============================================================================
	getClientWidth
==============================================================================*/

LONG CGadget::getClientWidth(void)
{

	RECT		lpRect;
	GetClientRect(hWnd, &lpRect);
	return ( lpRect.right - lpRect.left );

}

/*==============================================================================
	getClientHeight
==============================================================================*/

LONG CGadget::getClientHeight(void)
{

	RECT		lpRect;
	GetClientRect(hWnd, &lpRect);
	return ( lpRect.bottom - lpRect.top );

}

/*==============================================================================
	getWidth
==============================================================================*/

LONG CGadget::getWidth(void)
{

	RECT		lpRect;
	GetWindowRect(hWnd, &lpRect);
	return ( lpRect.right - lpRect.left );

}

/*==============================================================================
	getHeight
==============================================================================*/

LONG CGadget::getHeight(void)
{

	RECT		lpRect;
	GetWindowRect(hWnd, &lpRect);
	return ( lpRect.bottom - lpRect.top );

}

/*==============================================================================
	showPopupMenu
==============================================================================*/

void CGadget::showPopupMenu(WORD menuId, int x, int y)
{

	HMENU		hMenu, hPopup;

	// Charge un menu contextuel
	hMenu		= LoadMenu(getInstance(), MAKEINTRESOURCE(menuId));
	hPopup		= GetSubMenu(hMenu, 0);

	// Affiche le menu
	TrackPopupMenuEx(hPopup, 0, x, y, hWnd, NULL);
	DestroyMenu(hMenu);

}

/*==============================================================================
	stGadgetProc
==============================================================================*/

LRESULT CALLBACK CGadget::stGadgetProc(HWND hWindow, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	CREATESTRUCT	*lpParam = 0;
	CGadget			*pGadget = 0;
	int				iRet = 0;

	if ( uMsg == WM_CREATE ) {

		lpParam = (CREATESTRUCT *)lParam;

		if ( lpParam != NULL )
			pGadget = (CGadget *)lpParam->lpCreateParams;

		::SetWindowLong(hWindow, GWL_USERDATA, (LONG)pGadget);

		if ( pGadget != NULL )
			pGadget->hWnd = hWindow;

	} else {

		pGadget = (CGadget *)::GetWindowLong(hWindow, GWL_USERDATA);

	}

	if ( pGadget != NULL )
		iRet = pGadget->gadgetProc(uMsg, wParam, lParam);

	if ( iRet == 0 )
		return DefWindowProc(hWindow, uMsg, wParam, lParam);
	return 0;

}

/*==============================================================================
	gadgetProc
==============================================================================*/

int CGadget::gadgetProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return 0;
}

/* Fin de CGadget.cpp */
