/*==============================================================================
	CResampler.cpp
==============================================================================*/

#include "CResampler.hpp"

/*==============================================================================
	Constructeur
==============================================================================*/

CResampler::CResampler(WAVEFORMATEX *wSrcFx, char *lpBuf, unsigned int iLen)
{

	initBuffer(&_lpSource, wSrcFx, lpBuf, iLen);
	initBuffer(&_lpDestination, 0, 0, 0);

}

/*==============================================================================
	process
==============================================================================*/

char *CResampler::process(WAVEFORMATEX *lpDestFormat, char *lpDestBuf, unsigned int iDestLength)
{

	char				**lpParallelChannelsBuf;
	unsigned int		nSrcBlockIndex, nSrcBlockCount;
	unsigned int		nDestBlockIndex, nDestBlockCount;
	unsigned int		a, b, c;
	int					i, j, k;

	// Affecte le buffer de destination
	initBuffer(&_lpDestination, lpDestFormat, lpDestBuf, iDestLength);

	// Alloue la mmoire maximale ncssaire pour viter des erreurs
	nSrcBlockCount			= _lpSource.size / _lpSource.wFx.nBlockAlign;
	nDestBlockCount			= _lpDestination.size / _lpDestination.wFx.nBlockAlign;
	/*a						= max(_lpSource.wFx.nChannels, _lpDestination.wFx.nChannels);
	b						= max(_lpSource.wFx.nSamplesPerSec, _lpDestination.wFx.nSamplesPerSec);
	c						= max(_lpSource.wFx.wBitsPerSample, _lpDestination.wFx.wBitsPerSample);*/


	lpParallelChannelsBuf		= new char*[_lpSource.wFx.nChannels];
	for ( i = 0; i < _lpSource.wFx.nChannels; i++ ) {
		lpParallelChannelsBuf[i] = new char[ _lpSource.size / _lpSource.wFx.nChannels ];
		for ( j = 0; j < _lpSource.size / _lpSource.wFx.nChannels; j++ )
			CopyMemory(_lpSource.pBuf + j * _lpSource.wFx.nChannels, lpParallelChannelsBuf[i] + j, _lpSource.wFx.wBitsPerSample);
	}


	/*switch ( _wSrcFormat.nChannels ) {

		case 1: // Mono

			if ( _wDestFormat.nChannels == 2 )
				monoToStereo();
			break;

		/*case 2: // Stereo

			if ( _wDestFormat.nChannels == 1 )
				stereoToMono();
			break;*//*

	}*/

	/*nSrcBlockMax		= _iSrcBufferLength / _wDestFormat.nBlockAlign;

	for ( nSrcBlockIndex = 0; nSrcBlockIndex < nSrcBlockMax; nSrcBlockIndex++ ) {

		switch ( _wSrcFormat.nChannels ) {

			case 1: // Mono

				if ( _wDestFormat.nChannels == 2 )
					monoToStereo();
				break;

			/*case 2: // Stereo

				if ( _wDestFormat.nChannels == 1 )
					stereoToMono();
				break;*/
/*
		}

	}*/

}

/*==============================================================================
	monoToStereo
==============================================================================*/

void CResampler::monoToStereo(void)
{

	/*unsigned int			i;

	for ( i = 0; i < _iDestBufferLength; i++ ) {

		_pDestBuffer

	}*/

	/*int			nSrcBlocks, nDestBlocks;
	int			i, j, k;

	nSrcBlocks			= wTf->srcLength / iBlockSize;
	nDestBlocks			= wTf->destLength / iBlockSize;

	if ( nSrcBlocks > nDestBlocks )
		nSrcBlocks		= nDestBlocks;

	for ( i = 0; i < nSrcBlocks; i++ ) {
		for ( j = 0; j < 2; j++ ) {
			for ( k = 0; k < iBlockSize; k++ )
				wTf->destBuf[ 2 * iBlockSize * i + iBlockSize * j + k ]	 = wTf->srcBuf[ iBlockSize * i + k ];
		}
	}*/

}

/*==============================================================================
	initBuffer
==============================================================================*/

void CResampler::initBuffer(WAVEBUFFER *lpWaveBuffer, WAVEFORMATEX *lpWfx, char* lpBuf, unsigned int iLength)
{

	if ( lpWfx != 0 )
		CopyMemory(lpWfx, &lpWaveBuffer->wFx, sizeof(WAVEFORMATEX));
	lpWaveBuffer->pBuf		= lpBuf;
	lpWaveBuffer->size		= iLength;

}

/*==============================================================================
	freeBuffer
==============================================================================*/

void CResampler::freeBuffer(WAVEBUFFER *lpWaveBuffer)
{

	if ( lpWaveBuffer != 0 && lpWaveBuffer->pBuf != 0 ) {
		delete [] lpWaveBuffer->pBuf;
		ZeroMemory(&lpWaveBuffer->wFx, sizeof(WAVEFORMATEX));
		lpWaveBuffer->pBuf		= 0;
		lpWaveBuffer->size		= 0;
	}

}

/*==============================================================================
	free
==============================================================================*/

void CResampler::free(void)
{

	freeBuffer(&_lpDestination);

}

/* Fin de CResampler.cpp */
