/*==============================================================================
	CSample.hpp
==============================================================================*/

#ifndef __CSAMPLE__HPP__
#define __CSAMPLE__HPP__

#include "../windowsapi.h"
#include "CWaveOutBuffer.hpp"
//#include "CResampler.hpp"
#include "CWaveConverter.hpp"
#include <stdio.h>

/*==============================================================================
	Classe
==============================================================================*/

class CWaveOutBuffer;
//class CResampler;
class CWaveConverter;
class CSample
{

	public:

		char					lpFileName[MAX_PATH];
		int						pointerX;
		int						pointerY;
		CSample					*nextSample;

		CSample(char*);
		~CSample();

		// Lecture/pause/arrt
		BOOL 					load(void);
		void					close(void);
		BOOL					play(void);
		void					stop(void);

		// Buffer
		int						writeProc(char*);
		static int				stWriteProc(LPVOID, char*);

		// Sample
		WAVEFORMATEX			getFormat(void);
		unsigned long			getLength(void);
		unsigned long			getTimePosition(void);
		unsigned int	 		getTrack(void);
		void		 			setTimePosition(unsigned long);
		void	 				setTrack(unsigned int);
		void					select(void);
		void					unselect(void);
		BOOL					isSelected(void);

		// PCM
		int						getBuffer(char*, WAVEFORMATEX*, unsigned long, int);

	protected:

		typedef struct {
			unsigned long		RIFF_const;
			unsigned long		fileSize;
			unsigned long		WAVE_const;
			unsigned long		_fmt_const;
			unsigned long		formatSize;
		} WAVEFILEHEADER;

		typedef struct {
			char				*srcBuf;
			int					srcLength;
			char				*destBuf;
			int					destLength;
		} WAVETRANSFORM;

		// Buffer
		CWaveOutBuffer			*_gWaveOutBuffer;

		// Sample
		BOOL					_bSelected;
		unsigned long			_nTimePosition;
		unsigned int			_nTrack;

		// Fichier
		FILE					*_hFile;
		WAVEFORMATEX			_wFormatEx;
		unsigned long			_fStartPos;
		unsigned long			_fCurrentPos;
		unsigned long			_fEndPos;

		// Resample
		void					monoToStereo(WAVETRANSFORM*, int);

};

#endif

/* Fin de CSample.hpp */
