/*==============================================================================
	CSampleCollection.hpp
==============================================================================*/

#ifndef __CSAMPLECOLLECTION__HPP__
#define __CSAMPLECOLLECTION__HPP__

#include "../windowsapi.h"
#include "CMainDialog.hpp"
#include "CSamplePropDialog.hpp"
#include "CSample.hpp"
#include "CSampleList.hpp"

/*==============================================================================
	Classe
==============================================================================*/

class CMainDialog;
class CSamplePropDialog;
class CSample;
class CSampleList;
class CSampleCollection {

	public:

		HWND					hWnd;

		CSampleCollection(CMainDialog*);
		~CSampleCollection();

		void					showAddSampleDialog(void);
		void					showSamplePropDialog(void);
		void					addFile(char*);
		void					actualize(void);
		void					deleteFile(CSample*);
		void					deleteSelectedFiles(void);
		void					deleteAllFiles(void);

		void					onNotify(HWND, LPARAM);
		void					beginDrag(HWND, NMLISTVIEW*);
		void					moveDrag(HWND, LPARAM);
		void					endDrag(HWND, LPARAM);
		void					onEndLabelEdit(NMLVDISPINFO*);
		void					onKeyDown(NMLVKEYDOWN*);
		void					onLeftButtonDoubleClick(NMITEMACTIVATE*);
		void					onRightButtonDown(NMITEMACTIVATE*);
		void					onCommand(WPARAM, LPARAM);
		void					onDropFiles(WPARAM);

		static LRESULT CALLBACK	stListViewProc(HWND, UINT, WPARAM, LPARAM);

	protected:

		CMainDialog				*gParent;
		CSample					*gPreview;
		CSampleList				*sampleCollection;		// Bibliothque des sons
		WNDPROC					defWndProc;
		BOOL					dIsDraging;
		LPARAM					dItemDragParam;
		HIMAGELIST				dDragImageList;

};

#endif

/* Fin de CSampleCollection.cpp */
