/*==============================================================================
	CWaveOutBuffer.hpp
==============================================================================*/

#ifndef __CWAVEOUTBUFFER__HPP__
#define __CWAVEOUTBUFFER__HPP__

#include "../windowsapi.h"
#include "CThread.hpp"

/*==============================================================================
	Classe
==============================================================================*/

class CThread;
class CWaveOutBuffer
{

	public:

		typedef int (*WAVEWRITEOUTPROC)(LPVOID, char*);

		CWaveOutBuffer(long, WAVEWRITEOUTPROC, WAVEFORMATEX, int, int);
		~CWaveOutBuffer();

		//
		BOOL 					start(void);
		void					stop(void);

		void					threadProc(void);
		void					waveOutProc(UINT);
		static DWORD WINAPI		stThreadProc(PVOID);
		static void CALLBACK 	stWaveOutProc(HWAVEOUT, UINT, DWORD, DWORD, DWORD);

	protected:

		// Thread
		CThread					*_pThread;
		HANDLE					_hEvent;
		BOOL					_bTerminateThread;
		WAVEWRITEOUTPROC		_stWriteProc;

		// Audio
		WAVEFORMATEX			_wFormatEx;
		HWAVEOUT				_hWaveOut;
		WAVEHDR					*_wHeader;

		// Buffer
		char					**_pBuffer;
		long					_pObjData;
		int						_iCountBuffers;
		int						_iSizeBuffer;
		int						_iCurrentIndexBlock;

		void					prepareBuffer(void);
		void					writeBuffer(int);
		void					freeBuffer(void);

};

#endif

/* Fin de CWaveOutBuffer.hpp */
